<template>
  <div class="register">
    <div class="title-wrapper d-flex align-items-center">
      {{ $t('auth.register.title') }}
    </div>

    <div class="content-wrapper">
      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-email"></i></span>
        </div>
        <input class="form-control w-100 input_form" @keyup.enter="register" v-validate="'required|email|max:255'"
               data-vv-validate-on="none" @focus="resetError" :placeholder="$t('auth.placeholder.email')" v-model="user.email" name="email"
               type="text">
        <span class="invalid-feedback" v-if="errors.has('email')">
          {{ errors.first('email') }}
          <a href="javascript:void(0)" style="text-decoration: underline"
             v-if="errors.first('email') === $t('validation.verify_pending_email', {attribute: 'email'})"
             @click="sendVerifyUser"> {{$t('sign.resend')}}</a>
        </span>
      </div>

      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-password"></i></span>
        </div>
        <input class="form-control w-100 input_form" @keyup.enter="register"
               v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
               data-vv-validate-on="none" @focus="resetError" :placeholder="$t('auth.placeholder.password')" v-model="user.password"
               v-tooltip="$t('auth.register.password_tooltip')"
               name="password" type="password">
        <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-password"></i></span>
        </div>
        <input class="form-control w-100 input_form" data-vv-as="password confirmation" @keyup.enter="register"
               data-vv-validate-on="none" ref="password_confirmation" v-validate="'required'" @focus="resetError"
               :placeholder="$t('auth.placeholder.repeat_password')" v-model="user.password_confirmation"
               name="password_confirmation" type="password">
        <span class="invalid-feedback" v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
        <span class="invalid-feedback" v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-ID"></i></span>
        </div>
        <input class="form-control w-100 input_form" data-vv-as="password confirmation" @keyup.enter="register"
               data-vv-validate-on="none" @focus="resetError" :placeholder="$t('auth.placeholder.referral_code')"
               v-model="user.referral_id" name="referral_id" type="text">
        <span class="invalid-feedback" v-if="errors.has('referral_id')">{{ errors.first('referral_id') }}</span>
      </div>

      <div class="agree-wrapper form-group">
        <div class="position-relative form-check form-check-inline input_group">
          <input v-model="isAccpeted" id="inline-checkbox1" data-vv-validate-on="none" name="agree" type="checkbox"
                 v-validate="'required'" class="form-check-input form-check-input">
          <label for="inline-checkbox1" class="form-check-label form-check-label">
            {{ $t('auth.register.terms.agree') }} <a target="_blank" class="text-orange" href="/terms">{{ $t('auth.register.terms.title') }}</a></label>
        </div>
        <span class="invalid-feedback" v-if="errors.has('agree')">{{ $t('auth.register.terms.error') }}</span>
      </div>
      <div class="submit-btn text-center">
        <button type="button" @click="register" class="button-primary">{{ $t('auth.btn.upper_register') }}</button>
      </div>

      <div class="below-wrapper position-relative row form-group">
        <div class="text-center">
          <div class="position-relative form-check form-check-inline">
            <label class="form-check-label">
              {{ $t('auth.register.note') }}
              <a class="login-text text-orange" href="javascript:void(0)" @click="goToLoginPage">{{ $t('auth.btn.login') }}</a>
            </label>
          </div>
        </div>
      </div>
    </div>

    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>

<script>
  import rf from "../../../common/requests/RequestFactory";
  import ModalMixin from "../../../common/components/ModalMixin";
  import CheckAuthMixin from "./CheckAuthMixin";
  import RegisterSuccessfulModal from "./Modal/RegisterSuccessfulModal.vue";

  export default {
    data () {
      return {
        isAccpeted: false,
        user: {
          email: '',
          password: '',
          password_confirmation: '',
          referral_id: '',
        }
      };
    },
    computed: {
      isShowPasswordError () {
        return (
          this.errors.has('password') &&
          !this.errors.firstByRule('password', 'confirmed')
        );
      },
      isShowPasswordConfirmedError () {
        return (!!this.errors.firstByRule('password', 'confirmed') &&
          !this.errors.firstByRule('password_confirmation', 'required')
        );
      }
    },
    mixins: [CheckAuthMixin, ModalMixin],
    methods: {
      sendVerifyUser() {
        if (this.user && this.user.email) {
          rf.getRequest('UserRequest').sendVerifyUser({email: this.user.email}).then(() => {
            this.$toasted.show(this.$t('sign.resend_successful'), {
              theme: 'bubble',
              position: 'top-right',
              duration: 2000
            });
          });
        }
      },
      resetError () {
        this.errors.clear();
      },
      goToLoginPage () {
        this.$router.push('/login');
      },
      register () {
        this.$validator.validateAll().then(() => {
          if (this.errors.any() || !this.isAccpeted) {
            return;
          }
          rf.getRequest('UserRequest')
            .create(this.user)
            .then(res => {
              window.localStorage.removeItem('referralId');
              this.$broadcast('open-modal', RegisterSuccessfulModal, res.data);
            })
            .catch(error => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach(key => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
      }
    },
    created () {
      const url = new window.URL(window.location.href);
      const referralId = url.searchParams.get('referral_id');
      if (referralId) {
        window.localStorage.setItem('referralId', referralId);
      }
      this.user.referral_id = window.localStorage.getItem('referralId') || '';
    }
  };
</script>

<style lang="scss" scoped>
  @import "../../../../sass/mobile/typoVariables";

  .register {
    height: calc(100vh - 168rem);
    min-height: 460rem;
    background: $bg_primary;
    font-size: $medium;
    .title-wrapper {
      padding-left: 13rem;
      background-color: #21335b;
      height: 55rem;
      line-height: initial;
      font-size: 18rem;
      color: $white;
    }
    .content-wrapper {
      padding: 10rem $tiny 0 $tiny;
      input:-webkit-autofill,
      input:-webkit-autofill:hover,
      input:-webkit-autofill:focus textarea:-webkit-autofill,
      select:-webkit-autofill,
      select:-webkit-autofill:hover,
      select:-webkit-autofill:focus {
        border: none;
        -webkit-text-fill-color: #000;
        -webkit-box-shadow: 0 0 0px 1000px $white inset;
      }
      .invalid-feedback {
        font-size: 13rem;
        color: red;
        display: block;
        padding-left: $tiny;
      }
      .input-wrapper {
        height: 40rem;
        border-radius: 74rem;
        background-color: $white;
        margin-top: 20rem;
        position: relative;
        input {
          @extend .Medium-14;
          border: 1px solid transparent;
          color: #000;
          outline: none;
          &::placeholder {
            color: #cacaca;
          }
        }
      }
      .submit-btn {
        margin-top: 12rem;
        button {
          outline: none;
          @extend .button-12;
          background: transparent;
          width: 295px;
          height: 32rem;
          border-radius: 30rem !important;
          border: solid 1rem #fa7300;
          color: #fa7300;
          font-weight: bold;
          letter-spacing: 0.5rem;
        }
      }
      .agree-wrapper {
        padding: 19rem 0 12rem 15rem;
        @extend .Medium-14;
        color: #989898;
        position: relative;
        .form-check {
          display: table;
          input {
            display: table-cell;
            vertical-align: middle;
            margin-top: -1rem;
            margin-right: 7rem;
            background-color: #e0e0e0;
          }
          label {
            display: table-cell;
            vertical-align: middle;
          }
        }
        .invalid-feedback {
          top: 38rem;
          font-weight: 400;
        }
      }
      .below-wrapper {
        @extend .Medium-14;
        color: #989898;
        padding: 23rem 0;
        .login-text {
          font-size: $tiny;
          font-weight: bold;
          letter-spacing: 0.5px;
        }
      }
    }
  }

  .input_group {
    background-color: #f0f0f0;
    .input_form {
      border: 1px solid transparent;
      color: #000;
      padding-left: 40rem;
      height: 100%;
      border-radius: 74rem;
      outline: none;
      &:focus {
        box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
      }
    }
    .input_group_prepend {
      width: 19px;
      display: inline-block;
      margin-left: 16rem;
      line-height: 45rem;
      font-size: 15.5rem;
      position: absolute;
      color: #B0B0B0;
    }
  }

  .button-primary {
    width: 122rem !important;
    height: 35rem !important;
    border-radius: 30rem !important;
    background-color: #fa7300 !important;

    border: none !important;
    outline: none !important;
    color: white !important;
    cursor: pointer !important;
    letter-spacing: 1rem !important;
    font-weight: bold !important;
  }

  .text-link {
    color: #fa7300 !important;
    cursor: pointer !important;
    &:hover {
      text-decoration: underline;
    }
  }
  .invalid-feedback {
    color: red;
    position: absolute;
    text-align: left;
    bottom: -20rem;
    font-size: 10rem;
    left: 5rem;
  }
</style>
